unit QryThreadU;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls, Forms, Dialogs,
  DB, DBTables, StdCtrls, Grids, DBGrids, ExtCtrls;

type
  TForm1 = class(TForm)
    Session1: TSession;
    Query1: TQuery;
    Query2: TQuery;
    DataSource1: TDataSource;
    DataSource2: TDataSource;
    DBGrid1: TDBGrid;
    DBGrid2: TDBGrid;
    C1: TCheckBox;
    C2: TCheckBox;
    Timer1: TTimer;
    CreateThreadBtn: TButton;
    BeginThreadBtn: TButton;
    TThreadBtn: TButton;
    procedure CreateThreadBtnClick(Sender: TObject);
    procedure BeginThreadBtnClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure TThreadBtnClick(Sender: TObject);
  end;

  TQueryThread = class(TThread)
  private
    FQuery: TQuery;
  protected
    constructor Create(Query: TQuery);
    procedure Execute; override;
    procedure DoIt;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

var
  ThreadID1, ThreadID2: DWord;

{ Should take Param: Pointer, but an object reference is a pointer anyway }
{ Note the stdcall requirement for CreateThread }
function CreateThreadRoutine(Query: TQuery): Integer; stdcall;
begin
  Result := 0;
  Query.Open;
end;

{ Note no stdcall for BeginThread }
function BeginThreadRoutine(Param: Pointer): Integer;
begin
  Result := 0;
  TQuery(Param).Open;
end;

constructor TQueryThread.Create(Query: TQuery);
begin
  inherited Create(False);
  FreeOnTerminate := True;
  FQuery := Query;
end;

procedure TQueryThread.Execute;
begin
  Synchronize(DoIt);
end;

procedure TQueryThread.DoIt;
begin
  FQuery.Open;
end;

procedure TForm1.CreateThreadBtnClick(Sender: TObject);
begin
  Query1.Close;
  Query2.Close;
  { CreateThread(
      Security Attributes - usually nil,
      Initial thread stack size, 0 means process's stack size,
      Address of thread routine,
      32-bit user-defined parameter,
      Thread flags, eg. Create_Suspended,
      Thread ID variable); }
  CreateThread(nil, 0, @CreateThreadRoutine,
    Pointer(Query1), 0, ThreadID1);
  CreateThread(nil, 0, @CreateThreadRoutine,
    Pointer(Query2), 0, ThreadID2);
end;

procedure TForm1.BeginThreadBtnClick(Sender: TObject);
begin
  Query1.Close;
  Query2.Close;
  { BeginThread(
      Security Attributes - usually nil,
      Initial thread stack size, 0 means process's stack size,
      Thread routine,
      32-bit user-defined parameter,
      Thread flags, eg. Create_Suspended,
      Thread ID variable); }
  BeginThread(nil, 0, BeginThreadRoutine,
    Pointer(Query1), 0, ThreadID1);
  BeginThread(nil, 0, BeginThreadRoutine,
    Pointer(Query2), 0, ThreadID2);
end;

procedure TForm1.TThreadBtnClick(Sender: TObject);
begin
  Query1.Close;
  Query2.Close;
  TQueryThread.Create(Query1);
  TQueryThread.Create(Query2);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  C1.Checked := Query1.Active;
  C2.Checked := Query2.Active;
end;

end.
