unit ImgListU;

interface

uses
  WinProcs, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
  TForm1 = class(TForm)
    FormBackground: TImage;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormBackgroundMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    PicIndex: Integer;
    ImageList: TImageList;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
  Bmp: TBitmap;
begin
  FormBackground.Picture.LoadFromFile('\delphi\images\backgrnd\calendar.bmp');
  Bmp := TBitmap.Create;
  with Bmp do
    try
      LoadFromFile('\delphi\images\splash\16color\athena.bmp');
      { Set image list component's size }
{$ifdef Win32}
      ImageList := TImageList.CreateSize(Width, Height);
{$else}
      ImageList := TImageList.Create(Width, Height);
{$endif}
      { Add picture and generat mask }
      PicIndex := ImageList.AddMasked(Bmp, TransparentColor);
    finally
      Free;
    end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  ImageList.Free;
end;

procedure TForm1.FormBackgroundMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ImageList.Draw(FormBackground.Canvas, X, Y, PicIndex);
  FormBackground.Refresh;
end;

end.
